using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms;
using Syncfusion.Runtime.Serialization;
using Syncfusion.Windows.Forms.Tools;
using Syncfusion.Windows.Forms.Tools.XPMenus;
using System.Xml;
using System.IO;
using System.Text;

namespace _20278_tabbedmdi
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components=null;
		private Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar xpToolBar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
    private Button button1;
		private TabbedMDIManager tabbedMdiManager;
    private static int count;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

      XmlDocument xmlDoc = new XmlDocument();
      xmlDoc.Load("data.xml");

      XmlNodeList formList = xmlDoc.GetElementsByTagName("Form");
      Form2 child=null;

      foreach(XmlNode node in formList)
      {
        child = new Form2();
        child.Name = node.InnerText;
        child.Text = node.InnerText;
        child.MdiParent = this;
        child.Show();
      }

      count = this.MdiChildren.Length+1;
			this.tabbedMdiManager = new TabbedMDIManager();
			this.tabbedMdiManager.AttachToMdiContainer(this);

      //AppStateSerializer aser = new AppStateSerializer(SerializeMode.XMLFile, "..\\..\\stateinfo");
      //this.tabbedMdiManager.LoadTabGroupStates(aser);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.xpToolBar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.XPToolBar();
      this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
      this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
      this.button1 = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // xpToolBar1
      // 
      this.xpToolBar1.BackgroundColor = new Syncfusion.Drawing.BrushInfo();
      this.xpToolBar1.Dock = System.Windows.Forms.DockStyle.Top;
      this.xpToolBar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
            this.barItem1,
            this.barItem2});
      this.xpToolBar1.Location = new System.Drawing.Point(0, 0);
      this.xpToolBar1.Name = "xpToolBar1";
      this.xpToolBar1.Size = new System.Drawing.Size(568, 25);
      this.xpToolBar1.Style = Syncfusion.Windows.Forms.VisualStyle.Office2003;
      this.xpToolBar1.TabIndex = 1;
      this.xpToolBar1.Text = "xpToolBar1";
      // 
      // barItem1
      // 
      this.barItem1.CategoryIndex = -1;
      this.barItem1.ID = "Save";
      this.barItem1.Text = "Save";
      this.barItem1.Click += new System.EventHandler(this.barItem1_Click);
      // 
      // barItem2
      // 
      this.barItem2.CategoryIndex = -1;
      this.barItem2.ID = "Load";
      this.barItem2.Text = "Load";
      this.barItem2.Click += new System.EventHandler(this.barItem2_Click);
      // 
      // button1
      // 
      this.button1.Location = new System.Drawing.Point(467, 390);
      this.button1.Name = "button1";
      this.button1.Size = new System.Drawing.Size(89, 28);
      this.button1.TabIndex = 3;
      this.button1.Text = "Add Tab";
      this.button1.UseVisualStyleBackColor = true;
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(568, 430);
      this.Controls.Add(this.button1);
      this.Controls.Add(this.xpToolBar1);
      this.IsMdiContainer = true;
      this.Name = "Form1";
      this.Text = "Form1";
      this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		// Save TabGroupStates
    StringBuilder tabState=new StringBuilder();
		private void barItem1_Click(object sender, System.EventArgs e)
		{
			
      XmlDocument xmlDoc = new XmlDocument();
      xmlDoc.LoadXml("<?xml version='1.0' ?>" + "<Forms>" + "</Forms>");

      XmlElement root = xmlDoc.DocumentElement;

      foreach (Form childForm in this.tabbedMdiManager.MdiChildren)
      {
        XmlNode newElem = xmlDoc.CreateNode(XmlNodeType.Element, "Form", "");
        newElem.InnerText = childForm.Name;
        root.AppendChild(newElem);
      }
      
      xmlDoc.Save("data.xml");
      try
      {
        MemoryStream xmlStream = new MemoryStream();
        AppStateSerializer aser = new AppStateSerializer(SerializeMode.XMLFmtStream, xmlStream);
        
        this.tabbedMdiManager.SaveTabGroupStates(aser);
        aser.PersistNow();

        xmlStream.Position = 0;
        System.Xml.XmlTextReader reader = new System.Xml.XmlTextReader(xmlStream);
        string s=null;
        while (reader.Read())
        {
          s = reader.ReadString();
          if(s.Contains("<SOAP-ENV:Envelope")) break;
        }
        tabState.Remove(0, tabState.Length);
        tabState.Append(s);
        while (reader.Read())
        {
          tabState.Append(reader.ReadString());
        }
        Console.WriteLine(tabState);
        xmlStream.Close();
        reader.Close();
      }
      catch (Exception ex)
      {
        Console.Write(ex.Message);
      }
      
  }

		// Load TabGroupStates
		private void barItem2_Click(object sender, System.EventArgs e)
		{
     
      MemoryStream xmlStream = new MemoryStream();
      byte[] y = new UTF8Encoding(true).GetBytes(tabState.ToString());
      xmlStream.Write(y, 0, y.Length);
      xmlStream.Position = 0;
      Console.WriteLine(tabState.ToString());
      
			AppStateSerializer aser = new AppStateSerializer(SerializeMode.XMLFmtStream,xmlStream);
			this.tabbedMdiManager.LoadTabGroupStates(aser);
            
      xmlStream.Close();
		}
        
    private void button1_Click(object sender, EventArgs e)
    {
        Form2 child = new Form2();
				child.Text = "MDI Child" + (count).ToString();
				child.Name = "MDI Child" + (count++).ToString();
				child.MdiParent = this;
				child.Show();
			
			  this.tabbedMdiManager.AttachToMdiContainer(this);
    }		
	}
}
